;************************************************************************/
;*									*/
;*			Display Temperature				*/
;*                                                                      */
;************************************************************************/
;
display_temp_inline:				;inline !
	lcd_pos	0x00				;set line 1
	sbic	w1_in, w1_pin			;short circuit
	rjmp	_rse1
	text_out	msg_short
	rjmp	display_temp_ret

_rse1:	ldi	a0, search_first		;search sensor
	ldi	count, 0
_rse2:	cpi	a0, last_device
	brne	_rse3
	ldi	sensors, 0
	ldi	a0, search_first
_rse3:	sbrs	flags, convert			;skip during conversion
	rcall	w1_rom_search
	cpi	a0, presence_err
	brne	_rse4
	text_out	msg_bus_error		;bus error
	rjmp	display_temp_ret
_rse4:	inc	count
	cp	sensors, count			;selected sensor found
	brcc	_rse2
;-------------------------------------------------------------------------
	mov	a0, count			;display number
	rcall	dec_out
	lcd_char	':'
	sbrc	flags, convert
	rjmp	display_temp_ret
	lcd_char	' '
;-------------------------------------------------------------------------
	ldi	zl, romcode
	ld	a0, z				;device code:
	cpi	a0, 0x10			;DS1820
	ldi	count, 4
	breq	_rdt1
	ldi	count, 1
	cpi	a0, 0x28			;DS18B20
	breq	_rdt1
	text_out	msg_no_temp_sensor	;no temperature sensor
	rjmp	display_address
_rdt1:	ldi	a0, READ_T			;read temperature
	rcall	w1_byte_wr
	rcall	w1_byte_rd			;low byte
	mov	temp_l, a0
	rcall	w1_byte_rd			;high byte
	mov	temp_h, a0
	rjmp	_rdt3
_rdt2:	lsl	temp_l				;DS1820: 9 bit -> 12 bit
	rol	temp_h
_rdt3:	dec	count
	brne	_rdt2
;-------------------------------------------------------------------------
	sbrs	temp_h, 7			;test and display sign
	rjmp	_sig1
	lcd_char	'-'
	neg	temp_h				;two's complement
	neg	temp_l
	sbci    temp_h, 0
_sig1:
;-------------------------------------------------------------------------
	swap	temp_h
	swap	temp_l
	eor	temp_h, temp_l
	andi	temp_l, 0xF0			;clear bit3..0
	eor	temp_h, temp_l
	mov	a0, temp_h
	rcall	dec_out
	lcd_char	'.'
;-------------------------------------------------------------------------
; convert 1/16 -> 1/10: n * 16 + 13 / 26 (exact: n * 16 / 25.6)
	subi	temp_l, -0x0D			;+ 0x0D
	ldi	a0, '0' - 1
_dte1:	inc	a0
	subi	temp_l, 0x1A			;/ 0x1A
	brcc	_dte1
	rcall	lcd_data
	text_out	msg_grad
;-------------------------------------------------------------------------
;				Display 1 wire address
;-------------------------------------------------------------------------
display_address:
	lcd_pos	0x10 				;set line 2
	ldi	zl, romcode
_das1:	ld	a0, z
	rcall	hex_out
	inc	zl
	cpi	zl, romcode+8
	brne	_das1
	rjmp	display_temp_ret
;-------------------------------------------------------------------------
msg_grad:
	.db	0xDF, "C  ", 0
msg_no_temp_sensor:
	.db	"?      ", 0
msg_bus_error:
	.db	"Error      ", 0
msg_short:
	.db	"Short      ", 0
;-------------------------------------------------------------------------
;				Start Measuring and parasite power
;-------------------------------------------------------------------------
start_measure:
	sbis	w1_in, w1_pin			;if short circuit
	ret					;then abort
	rcall	w1_reset
	ldi	a0, SKIP_ROM
	rcall	w1_byte_wr
	ldi	a0, CONVERT_T
	rcall	w1_byte_wr			;start measuring
	sbi	w1_out, w1_pin
	sbi	w1_ddr, w1_pin			;parasite power on
	ret
;-------------------------------------------------------------------------
